(*
  Ita IDE Plugin

  Copyright (c) 2014 Lyna

  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
*)
unit UConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Spin, StdCtrls, ExtDlgs, pngimage, ComCtrls;

type
  TfrmConfig = class(TForm)
    edImagePath: TEdit;
    Label1: TLabel;
    btnSelectImage: TButton;
    Label2: TLabel;
    seLeft: TSpinEdit;
    seTop: TSpinEdit;
    Label3: TLabel;
    btnCancel: TButton;
    btnOK: TButton;
    opd: TOpenPictureDialog;
    Label4: TLabel;
    tbAlpha: TTrackBar;
    lblAlpha: TLabel;
    btnPreview: TButton;
    procedure btnSelectImageClick(Sender: TObject);
    procedure tbAlphaChange(Sender: TObject);
    procedure btnPreviewClick(Sender: TObject);
  end;

procedure ShowConfigDialog;

implementation

uses
  UMain;

{$R *.dfm}

procedure ShowConfigDialog;
var
  dlg: TfrmConfig;
  oldImagePath: string;
  oldLeft, oldTop: Integer;
  oldAlpha: Byte;
begin
  oldImagePath := ImageFileName;
  oldLeft := ImagePos.X;
  oldTop := ImagePos.Y;
  oldAlpha := ImageAlpha;

  dlg := TfrmConfig.Create(nil);
  try
    dlg.edImagePath.Text := ImageFileName;
    dlg.seLeft.Value := ImagePos.X;
    dlg.seTop.Value := ImagePos.Y;
    dlg.tbAlpha.Position := ImageAlpha;

    if dlg.ShowModal = mrOk then
    begin
      ImageFileName := dlg.edImagePath.Text;
      ImagePos.X := dlg.seLeft.Value;
      ImagePos.Y := dlg.seTop.Value;
      ImageAlpha := dlg.tbAlpha.Position;
    end
    else begin
      ImageFileName := oldImagePath;
      ImagePos.X := oldLeft;
      ImagePos.Y := oldTop;
      ImageAlpha := oldAlpha;
    end;

    LoadBackgroundImage;
  finally
    dlg.Free;
  end;
end;

procedure TfrmConfig.btnSelectImageClick(Sender: TObject);
begin
  if not opd.Execute then Exit;
  edImagePath.Text := opd.FileName;
end;

procedure TfrmConfig.tbAlphaChange(Sender: TObject);
begin
  lblAlpha.Caption := IntToStr(tbAlpha.Position);
end;

procedure TfrmConfig.btnPreviewClick(Sender: TObject);
begin
  ImageFileName := edImagePath.Text;
  ImagePos.X := seLeft.Value;
  ImagePos.Y := seTop.Value;
  ImageAlpha := tbAlpha.Position;

  LoadBackgroundImage;
end;

end.
